```
##########################
Changelog version 0.17.8
##########################
* 2017-02-12: Revision++
| 
* 2017-02-12: Add additional CreatureType check to each entity specific loop.
| 
| Should close #164 and close 159
| 
* 2017-02-12: Add Nearbyblock spawning option under JAS Log; defaults to disabled.
| 
| Add the blocks in a 3x3 grid centered on the spawn block. First block is origin, then above, then below. Coordinates are relative to spawn locatino.
| 
* 2017-02-12: Add default formatter to Dev directory; not quite right but close.
| 
* 2017-02-12: Update setup.
  
  setupDecompWorkspace = Provides FML/Forge/MC Source
  SetupDevWorkspace doesn't
  
##########################
Changelog version 0.17.7
##########################
* 2016-02-07: Fix issue with Material crashing on unknown material. It instead uses the materials Java SimpleClassName
| Revision++
| 
* 2016-02-07: More work on Op Refactor.
  
  LivingType triggered by events.
  
  TODO split some of LivingTypeSpawnTriggerBuilder into seperate classes
  
##########################
Changelog version 0.17.6
##########################
* 2015-09-14: Undo ChunkSpawn Tag changes. Delay chunk spawn logic processing until have the chunk is processed.
  
##########################
Changelog version 0.17.5
##########################
* 2015-09-12: Revision++
| 
* 2015-09-12: Seperate Passive Spawn tag, the usual "Spawn Tag" from the chunk spawn tag; now "Chunk Spawn Tag".
| 
| For previous versions, the default value for this new property "Chunk Spawn Tag" is the passive "Spawn Tag" expression.
| 
* 2015-09-12: Move tags around.
  
  Common Context now includes all the non-entity tags that are now marked Depreceated
  
##########################
Changelog version 0.17.4
##########################
* 2015-08-24: Fix an issue with the default EventSpawns file did not have the extention CFG
  
##########################
Changelog version 0.17.3
##########################
* 2015-08-22: Improve handling of poor user input for min/max chunk.
  Upon reading values from config; the smaller value will be set as minChunk.
  
  Spawnlistentry will automatically adjust min.max so that
  if min is set above max; max is set to min
  or if max is set to below min; min is set to max.
  
##########################
Changelog version 0.17.2
##########################
* 2015-07-21: Calculate CountInfo for despawning once per tick instead of for every entity's 60 ticks.
  More evenly distributes calculation load, improves consistency in performance cost, and scales significantly better with larger number of entities.
  
  Should fix #140
  
##########################
Changelog version 0.17.1
##########################
* 2015-07-18: Attempt to fix ConcurrentModificationException. Unknown cause, defensive coding measured taken.
| 
* 2015-07-18: Fix Effect Spawn List message format
| 
* 2015-07-18: Fix issue with entity sometimes spawning inside blocks
  Expand per pack size spawn attempt variance
  
##########################
Changelog version 0.17.0
##########################
* 2015-06-06: Merge branch 'dev'
| 
* 2015-06-06: curse release type should be part of build.gradle
| 
* 2015-06-06: To World Tags add boolean isClearWeather(); // Detect if it is Snow/Rain/Cloudy
| 
* 2015-06-06: Capitalize profile directory name
| 
* 2015-06-05: Profile specific folders.
| i.e. WorldSettings/Basic/<Settings> instead of WorldSettings/<Settings>
| Will be useful in the future. By default copies current world settings to new directory.
| 
* 2015-05-30: Note TODO
| 
* 2015-05-30: EntityDespawner. Extract SpawnerLogic to common source.
| 
* 2015-05-30: ExpProfile:
| Flesh out despawnrules.
| SaveToConfig + fixup arguments.
| 
* 2015-05-28: Spawner 'Refactor':
| * Seperate  Despawning from LivingHandler / SpawnListEntry.
| * StructureHandler Loader.
| 
* 2015-05-15: Add Setup_Spawnlistentry logging field to toggle detailed spawnlistentry adding / failing to add (failing only logged in debug mode)
| Close #130
| 
* 2015-05-15: Add passive spawn rtestriction to chunk spawns.
| This is not typical of vanilla behaviour, but does seem the expected and intutive to users.
| Will result in reduced chunk spawns, but should not heavily influence vanilla mobs.
| Subject to futher feedback.
| #134
| 
* 2015-05-15: Fix isTame tag to correctly recognize tamed horses
| Fix #131
| 
* 2015-05-15: Fix log call to actually report information
| Fix #133
| 
* 2015-05-15: Add check to see if World is null before attempting to determine if location is present.
| Improves compatability with mods that cause the structure objects to not be fully initialized.
| Fix #125
| 
* 2015-05-15: Add check to overworld structures to only enage when MapGenFeatures are enabled.
| Fixes #132
| 
* 2015-05-15: Add JASCA as Optional Library on curse builds
| 
* 2015-04-03: changelog to changelog not releasetype
| 
* 2015-04-03: Improve buildscript. Curseforge publishing of artifact and source jars; changelog autogenerated
| 
* 2015-03-24: obj.countEntitiesInRange and obj.countJASEntitiesInRange accept wildcard (*) as an entity name indicating any entity
| Revision++
| 
* 2015-03-22: Fix command in the form of /jas killall TYPE
| Should fix #120
| 
* 2015-03-22: Tweak interaction with Forge ShouldSpawn event. If JAS livinghandler OR spawnlistentry is overriden; ignore spawn event result.
| Should Fix #116
| 
* 2015-03-22: Fix eclipse launch settings
| 
*   2015-03-19: Merge branch 'refactor/sciptify' into dev
|\  
| | 
| * 2014-12-28: Basic start
| | 
| * 2014-12-25: Add SpawnTable for quick spawnlist access.
| | Add Profile and Counter
| | 
| * 2014-12-24: Move SpawnListEntryGenerator
| | 
| * 2014-12-23: New Biomegroup for each new mapping
| | 
| * 2014-12-23: BiomeGroup build using MVEL expressions. Must return ResultsBuilder object,
| | which is Created by calling Builder() context object.
| | 
| * 2014-12-23: [OCD] ConfigLoader should be configloader.
| | 
| * 2014-12-23: Fix imports to rest of JAS which has been broken into profile-style.
| | Move the Refactored Spawner into profile-style package under spawner
| | 
| * 2014-12-15: BiomeSpawnLists. Combine LH and LT into SLE. Generate defaults. Requires
| | tweaking LH; retintroducing it as effectively a LG for backwards
| | compatability as well as a link between LH and entity to spawn for SLE.
| | 
| * 2014-12-14: Remove commented out unused code
| | 
| * 2014-12-14: Mark Serialization methods
| | 
| * 2014-12-13: Re-add BiomeGroups. Realistically required for Backwards compatability and
| | with recent changes to make Groups generic should cost nothing
| | 
| * 2014-12-13: BiomeAttributes no longer have BiomeDictionary defaults
| | 
| * 2014-12-13: BiomeGroups divided into standalone BiomeMappings and BiomeAttributes.
| | BiomeDictionary references extracted to BiomeDictionaryGroups so that they can also be referenced without updating them.
| | Redefine many Groups operation used in LivingGroup to be generic ushc as parseContents and Sort as inner helper classes inside Group interface.
| | 
| * 2014-12-12: LivingHandler incorporating Mappings & Attributes objects.
| | No longer respawnable for selecting entities; thus doesn't need CreatureType.
| | 
| * 2014-12-12: LivingGroupRegistry broken into Mappings and Attributes objects which will be present in LivingHandlerRegistry.
| | 
| * 2014-12-12: Living Type and its loader. Using the new ConfigLoader to load its data.
| | 
| * 2014-12-12: Basic layout and parts. Not really connected yet.
|   
* 2015-03-19: Add WorldTime and dat to detemine time since beggining and current day
| 
* 2015-03-19: Update Forge Version.
| Make the ForgeGradle recommended runDir arg switch.
| Include Forge Readme for gradlew command references
| 
* 2015-03-18: Version++
| 
* 2015-03-18: More meaningful default function, still does nothing but makes better example.
| 
*   2015-03-18: Merge branch 'feature/eventspawns' into dev
|\  
| | 
| * 2015-03-16: Time group of helper functions for Tags.
| | 
| * 2015-03-15: Create common context for Spawn Events.
| | 
| | Count functions currently not supported.
| | 
| * 2015-03-15: Make Tag context object generic so we can use it in EventSpawns
| | 
| * 2015-03-15: Add breakcrop and breaktree spawn events
| | 
| * 2015-03-15: Context and SpawnBuilder cahnged to interfaces.
| | Spawnbuilder support for multiple entities.
| | 
| * 2015-03-15: Register events on both Forge and FML busses
| | 
| * 2015-03-06: EventSpawn system start
|   
* 2015-03-18: Tweak EffectiveSpawnList
| 
* 2015-03-18: Revision++
  
##########################
Changelog version 0.16.19
##########################
* 2015-04-03: Add JASCA as Optional Library on curse builds
| 
* 2015-04-03: changelog to changelog not releasetype
| 
* 2015-05-15: Improve buildscript. Curseforge publishing of artifact and source jars; changelog autogenerated
| 
| Conflicts:
| 	GEN-CHANGELOG.sh
| 	build.gradle
| 
* 2015-05-15: Revision++
| 
* 2015-05-15: Add Setup_Spawnlistentry logging field to toggle detailed spawnlistentry adding / failing to add (failing only logged in debug mode)
| Close #130
| 
* 2015-05-15: Add passive spawn rtestriction to chunk spawns.
| This is not typical of vanilla behaviour, but does seem the expected and intutive to users.
| Will result in reduced chunk spawns, but should not heavily influence vanilla mobs.
| Subject to futher feedback.
| #134
| 
* 2015-05-15: Fix isTame tag to correctly recognize tamed horses
| Fix #131
| 
* 2015-05-15: Fix log call to actually report information
| Fix #133
| 
* 2015-05-15: Add check to see if World is null before attempting to determine if location is present.
| Improves compatability with mods that cause the structure objects to not be fully initialized.
| Fix #125
| 
* 2015-05-15: Add check to overworld structures to only enage when MapGenFeatures are enabled.
| Fixes #132
| 
* 2015-04-03: Improve buildscript. Curseforge publishing of artifact and source jars; changelog autogenerated
  
##########################
Changelog version 0.16.18
##########################
* 2015-03-24: obj.countEntitiesInRange and obj.countJASEntitiesInRange accept wildcard (*) as an entity name indicating any entity
  Revision++
  
##########################
Changelog version 0.16.17
##########################
* 2015-03-22: Revision++
| 
* 2015-03-22: Fix command in the form of /jas killall TYPE
| Should fix #120
| 
* 2015-03-22: Tweak interaction with Forge ShouldSpawn event. If JAS livinghandler OR spawnlistentry is overriden; ignore spawn event result.
  Should Fix #116
  
##########################
Changelog version 0.16.16
##########################
* 2015-03-18: Revision++
| 
* 2015-03-18: For the Air spawn medium, include implicitly a check for Material that is nonliquid and does not obstruct movements.
  Allows for partial blocks such as snow and tallgrass to allow entities to spawn on them.
  #112 and #102
  
##########################
Changelog version 0.16.15
##########################
* 2015-03-13: Merge branch 'dev'
| 
* 2015-03-13: Revision++
| 
* 2015-03-13: Fix issue with writeNBT tag not writing over values that already exist.
  Should Fix #111
  
##########################
Changelog version 0.16.14
##########################
* 2015-03-07: Merge branch 'dev'
| 
* 2015-03-07: Revision++
| 
* 2015-03-07: Ensure entityPersistance Event is only processed ServerSide, should fix #107
| 
* 2015-03-07: Fix issue with writeNBT not parsing value arguments properly; resulting in NPE.
| Fix #109
| 
* 2015-03-07: Fix issue with not extracting the proper tags from the Optional class for SpawnListEntry
  Fixes #108 - com.google.common.base.Present cannot be cast to org.mvel2.compiler.ExecutableStatement
  
##########################
Changelog version 0.16.13
##########################
* 2015-01-05: Merge branch 'dev'
| 
* 2015-01-05: Revision++
| 
*   2015-01-05: Merge branch 'oldSpawnLoop' into dev
|\  
| | 
| * 2015-01-05: Tweak effectivespawnlist to reflect new spawn loop.
| | 
| * 2015-01-05: Revert spawnloop to resemble Prev0.15, primary difference is moving getSpawnListEntry below CreatureType.canSpawnHere.
|   
* 2015-01-05: Tweak CreatureType fallback when tags are absent to use .isNormalCube() instead of .isBlockNormalCube() as per vanilla.
| 
* 2015-01-05: Fix potential off-by-one error in Command CanSpawnHere due to rounding errors
  when converting position from double to int
  
##########################
Changelog version 0.16.12
##########################
* 2014-12-23: Merge branch 'dev'
| 
* 2014-12-23: Revision++
| 
* 2014-12-23: Abstract entity counting in the spawner, no longer check chunks.
  
##########################
Changelog version 0.16.11
##########################
* 2014-12-22: Merge branch 'dev'
| 
* 2014-12-22: Export ImportedSpawnlist to "ImportedSpawnlists.cfg".
  Revision++
  
##########################
Changelog version 0.16.10
##########################
* 2014-12-22: Merge branch 'dev'
| 
* 2014-12-21: Make use of Forge AT making ChunkProviderServer.innerChunkProvider public to not use reflection
| 
* 2014-12-21: 0.16.10 0 candidate. Disable alternative profiles; not ready yet.
| Includes Reflection optimization and KillAll arg fix
| Revison++
| 
*   2014-12-21: Merge branch 'feature/toggleableSpawner' into dev
|\  
| | 
| * 2014-12-21: Cache reflection calls insteaf of Access Transformer.
| | 
| | Use World.Unloead to clear WeakReference cache when dimension unloads.
| | 
| * 2014-12-21: Add AccessTransformer to expose StructureInterpreeter fields so reflection isn't needed
| | 
| * 2014-12-21: Fix proxy package
| | 
| * 2014-12-21: Fix off by one argument bug in full version of killall command
| | 
| * 2014-12-19: Rename TAGS to BASIC
| | 
| * 2014-12-19: Rearrange the packages so they make some sense
| | 
| * 2014-12-19: Throw exception when spawningProfile  doesn't match a known profile instead of defailting to MVEL
| | 
| * 2014-12-19: Fix proxy package name
| | 
| * 2014-12-19: Move GLOBAL SETTINGS category of entries to top of GlobalSettings file
| | 
| * 2014-12-19: Prune useless legacy files
| | 
| * 2014-12-19: Profile setting in GlobalProperties.CFG that allows toggling between MVEL and TAGS
| | 
| * 2014-12-19: Bring in 0.14.13 source to become the 'Tags' spawner.
|   
* 2014-12-21: Add AccessTransformer to expose StructureInterpreeter fields so reflection isn't needed
  
##########################
Changelog version 0.16.9
##########################
* 2014-12-16: Forbid monster spawns in Peaceful
| 
* 2014-12-16: Merge branch 'dev'
| 
* 2014-12-16: Revision++
| 
* 2014-12-16: Fix Monster and Ambient using && instead of || during spawn conditiosn. Will fix the raining Zombies and Creeper issue.
| 
* 2014-12-16: Reinstate cap check both at beggining and during spawn. i.e. Fix runaway vanilla squid spawns do to check only at begining of spawn cycle.
| 
* 2014-12-15: Merge branch 'feature/ASMMVEL' into dev
| 
* 2014-12-15: Enable MVEL default ASM optimizer now that integer bug in MVEL is fixed
| 
* 2014-12-15: Update MVEL2 to 2.2.2 Final
  
##########################
Changelog version 0.16.8
##########################
* 2014-12-14: Add quickexit such that entities are not counted if there are no CreatureTypes ready to process it.
| 
* 2014-12-14: Move CreatrueType max spawn check outside spawn loop.
| Should reduce unnecssary checks once caps are filled.
| 
* 2014-12-14: Revision++
| 
* 2014-12-14: Merge branch 'dev'
| 
* 2014-12-14: Fix LivingHandler parsing issue where despawnrate value was assigned to entity cap.
| despawnAge and despawnRate are now correctly set.
| Closes #100
| 
* 2014-12-13: Fix biome expression issue where A| B| were being backed by the wrong map.
  Closes #99
  
##########################
Changelog version 0.16.7
##########################
* 2014-12-13: Merge branch 'dev'
| 
* 2014-12-13: Fix issue with spawnlists not regenerating under all conditions
  
##########################
Changelog version 0.16.6
##########################
* 2014-12-13: Merge branch 'dev'
| 
* 2014-12-13: Fix entity duplication logic as well as logging format
| Fix shouldspawn log printing for adding to the invalid spawnlist
| 
* 2014-12-12: Change Json Error logging. Chain exceptions instead of logging error to ensure they are printed together
  
##########################
Changelog version 0.16.5
##########################
* 2014-12-12: Merge branch 'dev'
| 
* 2014-12-12: Fix bug where BiomeGroups were being built without proper Attribute Map
| 
* 2014-12-12: Add toggle to determine if SpawnListEntries with a weight of zero are removed.
  True by default. Global such that it can be toggled before spawnlistentries are generated.
  
##########################
Changelog version 0.16.4
##########################
* 2014-12-12: Fix default Creature spawn conditions: were supposed to be || but we &&.
  
##########################
Changelog version 0.16.3
##########################
* 2014-12-09: Fix issue with BiomeSpawnList entries regenerating when they are set to not spawn (i.e. weight == 0)
  
##########################
Changelog version 0.16.2
##########################
##########################
Changelog version 0.16.1
##########################
* 2014-12-07: Merge branch 'dev'
| 
* 2014-12-07: Revision++
| 
* 2014-12-07: Be more explicit defining Srings for Block, BlockFoot, Entities, and WriteNBT Tag conversion.
| Use ' instead of " to keep GSON happy and avoid clunky escaping (\").
| 
* 2014-12-07: Add Expression to MVEL crash reporting.
  
##########################
Changelog version 0.16.0
##########################
* 2014-12-06: Merge branch 'dev16' into dev
| 
* 2014-12-06: Version++
| 
* 2014-12-06: Include provider name with dimension ID for Dimension Command
| 
* 2014-12-04: Add 2 WorldAccessor tags.
| long totalTime - Total time for the world
| long timeofDay - The current world time in ticks, ranging from 0 to 23999.
| Closes #33
| 
* 2014-12-04: Command CanSpawnHere now reports the probability success / # of trials of an entity to spawn in a given location, if at all. Ommitted if 100%
| Closes #76
| 
* 2014-12-04: Actually register CommandDimension so it will work.
| 
* 2014-12-04: Add Command entitystats to calculate mean/median/mode for entity density and entity distance to player
| Closes #70
| 
* 2014-12-04: Add command to determine the current dimension the player is in
| Closes #91
| 
*   2014-12-04: Merge branch 'feature/MVELErrorCatching' into dev16
|\  
| | 
| * 2014-12-04: Add Better, though not great, error messages to MVEL execution blocks to better assist debugging
|/  Close #89
|   
*   2014-12-04: Merge branch 'feature/errorspammingconsole' into dev16
|\  
| | 
| * 2014-12-04: Fix duplicate entity class / mappings detection.
|/  Close #86
|   
* 2014-12-04: Merge branch 'feature/instantdespawn' into dev16
| 
* 2014-12-04: Remove unneccesary calcs in desawn determination method
| 
* 2014-12-03: Switch from PersistenceRequired hackery to using AllowDespawn forge event.
| Should provide better compatability, also allow entities to despawn normally once JAS is uninstalled or despawn tags are no longer used by user.
| 
* 2014-12-03: Add InstanctDespawn Tag. For compatability, only works if a despawn tag is present.
  Value key is "InstantDespawns Tags" to livinghandler as you would despawn tags.
  Closes #53
  
##########################
Changelog version 0.15.2
##########################
* 2014-12-03: Fix issue where despawn field for saving was reading from the spawn expression field.
  Should fix #90
  
##########################
Changelog version 0.15.1
##########################
* 2014-12-03: Fix issue where converter was not convtering maxspawnheigtht and minspawnheight tags properly,
  
##########################
Changelog version 0.15.0
##########################
* 2014-12-02: Merge branch 'dev'
| 
| Conflicts:
| 	build.gradle
| 	src/main/java/jas/common/command/CommandCanSpawnHere.java
| 
*   2014-12-01: Merge branch 'feature/effectivespawnlist' into dev15
|\  
| | 
| * 2014-12-01: Add Command effectivespawnlist generates a 'spawnlist' for the area surrounding the player based on simulating the spawning process
| | Format:
| | /jas effectivespawnlist <Player=CommanderSender> <CreatureType=*> <cycles=3> <ChunkDistance=8>
| | /jas effectivespawnlist <CreatureType> <cycles> <ChunkDistance>
| | /jas effectivespawnlist <CreatureType> <cycles>
| | /jas effectivespawnlist <CreatureType>
| | 
| * 2014-12-01: temp Commit... working on spawn bug come back to this
|/  
|   
* 2014-12-01: Fix issue with entities spawning uncontrollable as they were not counting towards their caps
| 
* 2014-11-29: Fix issue default spawnlistentries 0-0-0-0
| 
* 2014-11-27: CreatureType CREATURE default expression to MVEL
| 
* 2014-11-25: Create spawnlistentries for any newly added biome or entity mapping
| 
* 2014-09-06: Misc changes to Tags
| 
* 2014-09-06: Methods need not accept locations
| 
* 2014-09-06: Update readme to include info on MVEL being included. Could not find standalone copyrigth statement other than it is under Apache 2.0 and was developed primarily Mike Brock
| 
* 2014-09-06: Include MVEL source in the project as FML doesn't have an easy way to add a lib dependency.
| If more projects need it, MVEL could be extracted to a coremod/FMLmod so that projects could properly depend on it.
| 
* 2014-09-06: version to 15.DEV1 for initial trial
| 
* 2014-09-06: remove Jeval lib
| 
* 2014-09-06: Merge branch 'dev' into dev15
| 
| Conflicts:
| 	src/main/java/jas/common/command/CommandCanSpawnHere.java
| 	src/main/java/jas/common/spawner/creature/handler/parsing/keys/KeyParserBlockRange.java
| 
* 2014-09-06: Add entity tag. Expects the return of a JAS entity name to spawn.
| 
* 2014-09-06: Add Log utility tag prepends [TAG_LOG] to message.
| 
* 2014-09-06: Allow customization of loop iterations.
| 
* 2014-09-06: Have a second local entity count, 'pack' to counteract the spawnInThisLoop (previously using the packsize count)
| Provides more options for expressions.
| 
* 2014-09-06: pack spawn loop coord randomization should be done primarily horizontally
| 
* 2014-09-06: Add CountInfo to Tags to allow logic based on number of entities loaded or recently spawned.
| 
* 2014-09-06: Convert SpawnListEntry tags to the expression format
| 
* 2014-09-05: OR == || and AND == &&
| 
* 2014-09-05: Fix any tags relying on searchAndEvaluate. It was completely wrong, in so many ways.
| 
* 2014-09-05: Fix handler new group setup using creaturetype as handlerId
| 
* 2014-09-03: Fix spawn crash caused by LivingHandlers without any valid entries
| 
* 2014-09-03: Fix creaturetype canspawn always return false
| 
* 2014-09-02: Fix importing issues and config formating
| 
* 2014-09-01: Add expression support for CreatureType.
| Attempts to convert old tags to expressions.
| Converter still doesn't convert properly,thuogh save/load of 2.0 settings seems to function
| Note OptimizerFactory.setDefaultOptimizer("reflective") is needed to function "ASM" doesn't work with all tags.
| Untested theory is that it has to do with the anonymous classes used in methods i.e. solidside.
| 
* 2014-09-01: Add expression support for CreatureType.
| Convert old tags to expressions. Add toExpression method to KeyParsers.
| 
* 2014-08-31: Create Tag Object to allow MVEL to call methods representing tags
| KeyParserWriteNBT no longer functions
| 
* 2014-08-31: Add MVEL depency and lib for dev
| 
* 2014-08-30: Fix issue with SpawnRange tag crash caused to accessing objects before construction
| 
* 2014-08-30: Consolidate some methods in spawn loop such as several CreatureType CanSpawn
| CountInfo tracks packsize
| 
* 2014-08-30: Remove old spawn loop
| 
* 2014-08-29: Reorganize SpawnLoop. Consolidate counting information into single object.
| Change order checks are done in preparation of them being consolidated to allow tags/parsing to fulfill their functions.
| 
* 2014-08-29: Merge LivinGroup into LivingHandler. This consolidates the 'livingID' into a single object.
| The ability to have groups within groups is no longer valid. Each LivingHandler can be parsed independently. Atributes are still available for grouping.
| Loss of feature is balanced by ease of use.
| 
* 2014-08-27: Add SideEffect to Add/update/remvoe LivingGroup. LivingHandlers are added/removed as well as updating spawnlists for biomes and structures
| 
* 2014-08-27: BoimeSpawnlist only adds spawns to valid or invalid if creaturetype != NONE
| 
* 2014-08-26: Add add/remove mod methods to StructureHandler
| 
* 2014-08-25: Formatting to biomeGroupRegistry
| 
* 2014-08-25: Add Sideeffect handing for UpdateBiomeGroup Modification: if group has changed or is empty empty spawnlists and generate new ones
| Add modification method to spawnlistregistry to add multiple spawnlistentries
| 
* 2014-08-23: When updating biomegroup the new BiomeGroupId may not be identical to the old BiomeGroupId
| 
* 2014-08-23: Add Side effects handling to ModRemoveBiomeGroup:
| Remove spawnlists associated with the biomegroup.
| 
* 2014-08-23: Expose inner spawn data structures as public final. The reference shouldn't change so this should be acceptable. Makes mods function in a cleaner manner as well.
| Method calls for Modifications interface order still matters.
| 
* 2014-08-22: Fix ChunkSpawnChance being read as an integer. closes #79
| 
* 2014-08-21: Document requirement for modification call declaration.
| Was required anyway to ensure modifications leave database valid, doubly so now that references are being used (i.e. ModAddBiomeGroup).
| 
* 2014-08-21: Add SideEffect handling for ModAddBiomeGroup. Generate a spawnlist for the newly created group
| 
* 2014-08-21: Shouldn't be clearable. Cannot recreate anyway.
| 
* 2014-08-21: Might as well document that it needs to be done eventually
| 
* 2014-08-21: Obvious mistake
| 
* 2014-08-20: Add Command to add/remove/update BiomeSpawnList.
| Update currently functions as replace.
| 
* 2014-08-18: Add Command to add/remove/update LivingHandler.
| Update currently functions as replace.
| 
* 2014-08-18: remove useless comment
| 
* 2014-08-18: Forgot to register commands
| 
* 2014-08-18: Add commands to add/remove/update CreatureTypes
| Currently Update functions as replace.
| 
* 2014-08-17: Add commands to add/remove/update LivingGroups.
| Currently Update functions as replace.
| 
* 2014-08-17: Add appropriate autocompletes to CommandModBiomeGroup
| 
* 2014-08-17: Commands Need to be registered
| 
* 2014-08-17: Case None should throw format exception
| 
* 2014-08-17: Add BiomeGroup mod support for add/remove/update biome groups.
| Update is currently functions as a replace, though more atomic support may be supported in the future.
| 
* 2014-08-17: Enable modifications to be processed n SpawnerTicker loop.
| Move Command Load/Save over to new system
| 
* 2014-08-15: Move spawn logic to within own event such that changes to spawn data can be changed without risking spawning reading invalid data
  
##########################
Changelog version 0.14.13
##########################
* 2014-10-25: Revision++
| 
* 2014-10-25: 'Fix' issue with entities that use client side classes. They will now print an error log when accessed.
  Closes #84
  
##########################
Changelog version 0.14.12
##########################
* 2014-09-18: Fix issue with CanSpawnHere never finding match for structures
  
##########################
Changelog version 0.14.11
##########################
* 2014-09-04: EmptyVanillaSpawnlists also clears nether structure spawnlist.
| Closes #83
| Revision++
| 
* 2014-08-31: Throw error exception to indicate to user the entity doesn't belong to any groups
  
##########################
Changelog version 0.14.10
##########################
* 2014-08-31: Fix issue with spawnrange and despawnage not being called properly
  
##########################
Changelog version 0.14.9
##########################
* 2014-08-30: Revision++
| 
* 2014-08-30: Fix issue with SpawnRange tag crash caused to accessing objects before construction
  
##########################
Changelog version 0.14.8
##########################
* 2014-08-29: Fix issue with CommandCanSpawnHere using FML instead of JAS mapping.
  Closes#82
  
##########################
Changelog version 0.14.7
##########################
* 2014-08-22: Revision++
| 
* 2014-08-22: Fix ChunkSpawnChance being read as an integer. closes #79
  
##########################
Changelog version 0.14.6
##########################
*   2014-08-15: Merge branch 'dev'
|\  
| | 
| * 2014-08-15: revision++
| | 
| * 2014-08-15: Files with invalid JSON now also print the file name and path to the log along with the exception.
| | 
| * 2014-08-15: Fixed a bug where newly deleted spawnlistentry files did not re-populate themselves when removed entirely
|   
* 2014-08-15: Recommiting gradlew because git struggled with binaries that change
| 
* 2014-08-15: Update to MC-Forge v1.7.10
  
##########################
Changelog version 0.14.5
##########################
* 2014-04-15: Revision++
| 
* 2014-04-15: Use isNormalCube() and not isBlockNormalCube() as one is randomly client side only for no raisin.
  
##########################
Changelog version 0.14.4
##########################
* 2014-04-14: Attempt to handle null biome names #1
| 
* 2014-04-14: Revision++
| 
* 2014-04-14: Fix saveworld error trying to delete already deleted files
| 
* 2014-04-14: Fix livingroup parsing issue with multiple entity modids
  
##########################
Changelog version 0.14.3
##########################
* 2014-04-14: Revision++
| 
* 2014-04-14: Only Cancel chunkspawning for non-blacklisted biomes. Also, create a toggle in global properties.
  
##########################
Changelog version 0.14.2
##########################
* 2014-04-13: Revision++
| 
* 2014-04-13: PopulateChunkEvent.Populate event should set result not be cancelled
  
##########################
Changelog version 0.14.1
##########################
* 2014-04-12: Switch chunk spawn event to occur at PopulateChunkEvent.Populate.EventType.ANIMALS which custom dimensions should call for compatability
| 
* 2014-04-12: Merge branch 'dev'
| 
* 2014-04-12: Revision++
| 
* 2014-04-12: Field should be private as its only use is internal
| 
* 2014-04-12: Add FILE_VERSION to temporarySaveSettings.cfg
| 
* 2014-04-12: Fix LivingGroup parseer not handling the case where mappings are absent
| 
* 2014-04-12: BiomeSpawnList JSON should not save empty Tag strings to save space
| 
* 2014-04-11: Change biomegroups CFG to regenerate attribute and biomegroups when those json entries are deleted
| 
* 2014-04-11: Fixes for issues related to missing entities/groups. Enforeces 1 group == 1 handler contract.
  
##########################
Changelog version 0.14.0
##########################
* 2014-04-08: Merge branch 'dev' for v0.14 release
| 
| Conflicts:
| 	src/jas/common/spawner/biome/group/BiomeGroupRegistry.java
| 	src/jas/common/spawner/creature/type/CreatureType.java
| 	src/main/java/jas/common/DefaultProps.java
| 	src/main/java/jas/common/spawner/creature/handler/LivingGroupRegistry.java
| 
* 2014-04-08: Search through spawnlist when entity does not have a type
| 
*   2014-04-08: Merge branch 'dev14' into dev
|\  
| | Attempt to fix some world-salad created from shitty 'succesful' autoresolve merging
| | 
| | Conflicts:
| | 	src/jas/common/GlobalSettings.java
| | 	src/jas/common/config/EntityCategoryConfiguration.java
| | 	src/jas/common/spawner/biome/group/BiomeGroupRegistry.java
| | 	src/jas/common/spawner/creature/handler/LivingHandlerRegistry.java
| | 	src/jas/common/spawner/creature/type/CreatureTypeRegistry.java
| | 	src/main/java/jas/common/DefaultProps.java
| | 	src/main/java/jas/common/spawner/creature/handler/LivingGroupRegistry.java
| | 	src/main/java/jas/common/spawner/creature/handler/parsing/keys/KeyParserBiome.java
| | 
| * 2014-04-08: Added errorhandling to generating Fml->Jas name mappings.
| | Conflicting mappigns will not be added, but are documented with either A or B depending on if it occurs during reading config or generating entries not in the config.
| | A: 'Duplicate entity class detected. Ignoring FML,JasName pair [{FmlName},{JasName}] for class, class {JavaClass}' or
| | B: 'Duplicate entity mapping generating new entities. Entity-FML mapping Mapping [{JasName}] already exists. Iggnoring: [FMLname:class]=[{FmlName}:{javaClass}]'
| | 
| * 2014-04-08: Fix off by one error when selecting entities to spawn.
| | 
| * 2014-04-08: Fix biomegroups not sorting groups with operators properly.
| | 
| * 2014-04-08: Add FILE_VERSION to structure cfg
| | 
| * 2014-04-08: Add FILE_VERSION to WorldGlobalSettings
| | 
| * 2014-04-08: Allow readFromGson to be able to provide constructor arguments (which also select constructor)
| | BiomeSpawnlist includes a fileVersion
| | 
| * 2014-04-07: getConstructor(...) only fetches public, getDeclaredConstructor(...) will fetch the desired private constructors
| | 
| * 2014-04-07: Add FILE_VERSION to LivingHandlers
| | 
| * 2014-04-07: Handler builder should implement builder pattern
| | 
| * 2014-04-06: Update ForgeGradle and Forge. Apparently I forgot to do this earlier.
| | 
| * 2014-04-06: Add CreatureType version along with Serializer and Deserializer
| | 
| * 2014-04-06: GsonHelper add getAsOrDefault line of helpers. As well, throw IllegalArgumentException when serialized class cannot be instantiated from no arg constructor
| | 
| * 2014-04-06: Add GSON unwrapping helpers from MOSI
| | 
| * 2014-04-05: Add Jeval, update to latest Forge version, and update ForgeGradle to 1.2
| | 
| * 2014-04-05: Properyl setup SpawnerTicker so it ticks on an integrated server
| | 
| * 2014-04-05: Switch logging to Log4j
| | 
| * 2014-04-03: Tweak SaveConfig. Each world does not, by default, gets it Configuration setting: they all use the default one. World specific configuration can be added to the WorldProfiles array.
| | 
| * 2014-04-02: Add a FILE_VESION property to BiomeBlacklist.
| | 
| * 2014-04-02: GsonHelper can create a new isntance even if the constructor is private, allowing serialization classes to keep serialize-only constructors while not exposing them to everyone
| | 
| * 2014-04-02: LivingGroupSaveObject should use optionals instead of null to indicate absence
| | 
| * 2014-04-02: Fix 1.7 compile errors
| | 
| * 2014-03-26: Port to gradle setup for mc17. JAS compatability will be spun off to its own project
| | 
| * 2014-01-09: LivingGroup Gson in the same for as biome group using cateogires instead of fields and also add file version.
| | 
| * 2014-01-09: Add FileVersion to SaveConfig
| | 
| * 2013-12-27: Fix NPE when reading BiomeGroup Gson
| | 
| * 2013-12-24: Tweak BiomeGroup save format. Category and GroupId inferred from category entry is in. Remove explicit fields.
| | 
| * 2013-12-16: Gsonify global settings. Logging settings get their own file.
| | 
| * 2013-12-16: Gsonify biomeblacklist. It now has its own file.
| | 
| * 2013-12-16: Purge old Configuration setup, only GlobaProperties to go.
| | 
| * 2013-12-16: Move tempSaveSettings into general world directory.
| | Set universal cleanse to affect entity handler and spawnlist folder.
| | 
| * 2013-12-14: Gsonify biome SpawnListEntries.
| | Remove structure handler old config loading.
| | Fix "Use_Universal_Entity_CFG" and "Sort_Creature_By_Biome" being switched when serializing.
| | 
| * 2013-11-25: StructureHandlerRegistry instance persists. Tweak accesors now that it contains immutable lists.
| | 
| * 2013-11-25: Gsonify StructureSpawnlists
| | 
| * 2013-11-23: Gsonify LivingHandlers.
| | Split handlers from spawnlistentries. They are not under savename/EntityHandlers instead of ModEntitySettings
| | 
| * 2013-11-19: "LivingGroups.cfg" not "LivingGroupsGSON.cfg"
| | 
| * 2013-11-19: CreatureTypeRegistry does't need to create a new instance every time WorldSettings reloads.
| | 
| * 2013-11-19: Gsonify CreatureType
| | 
| * 2013-11-19: Gsonify LivingGroups
| | 
| * 2013-11-16: Use Treemaps instead of hashmaps so that configs are sorted lexicographically (alphabetically)
| | Also, found generic sort by value. Could be useful.
| | 
| * 2013-11-16: Gsonify BiomeGroupRegistry
| | 
| * 2013-11-13: Gsonify SaveConfig, WorldProperties, and TempEntitySettings. Part II.
| | 
| * 2013-11-13: Fix build error in BiomeGroupRegistry when creating fresh configs.
| | 
| * 2013-11-13: Gsonify SAveConfig, WorldProperties, and TempEntitySettings.
| | 
| * 2013-11-11: Minor Formatting
| | 
| * 2013-11-07: BiomeGroupRegistry Immutable-ify
|   
* 2014-01-26: Added errorhandling to generating Fml->Jas name mappings.
| Conflicting mappigns will not be added, but are documented with either A or B depending on if it occurs during reading config or generating entries not in the config.
| A: 'Duplicate entity class detected. Ignoring FML,JasName pair [{FmlName},{JasName}] for class, class {JavaClass}' or
| B: 'Duplicate entity mapping generating new entities. Entity-FML mapping Mapping [{JasName}] already exists. Iggnoring: [FMLname:class]=[{FmlName}:{javaClass}]'
| 
* 2013-11-29: Create option for whether chunks are loaded or created for counting. Default is disabled.
| 
* 2013-11-27: Search through spawnlist when entity does not have a type
| 
* 2013-11-19: Fix biomegroups not sorting groups with operators properly.
  
##########################
Changelog version 0.13.6
##########################
* 2014-03-19: Fix creature type spawn medium being incorrectly set
  
##########################
Changelog version 0.13.5
##########################
* 2014-02-11: Fix off by one error when selecting entities to spawn.
  
##########################
Changelog version 0.13.4
##########################
* 2014-01-26: Added errorhandling to generating Fml->Jas name mappings.
  Conflicting mappigns will not be added, but are documented with either A or B depending on if it occurs during reading config or generating entries not in the config.
  A: 'Duplicate entity class detected. Ignoring FML,JasName pair [{FmlName},{JasName}] for class, class {JavaClass}' or
  B: 'Duplicate entity mapping generating new entities. Entity-FML mapping Mapping [{JasName}] already exists. Iggnoring: [FMLname:class]=[{FmlName}:{javaClass}]'
  
##########################
Changelog version 0.13.3
##########################
* 2013-11-19: Fix biomegroups not sorting groups with operators properly.
  
##########################
Changelog version 0.13.2
##########################
* 2013-11-14: Merge branch 'dev'
| 
* 2013-11-14: Extend BiomeTag functionality to allow BiomeAttributes or BiomeGroups by prefixing with A| or G| repsectively.
| 
* 2013-11-10: Fix issue with Custom Entity Categories not saving
  
##########################
Changelog version 0.13.1
##########################
* 2013-11-10: Fix issue with Custom Entity Categories not saving
  
##########################
Changelog version 0.13.0
##########################
* 2013-11-03: Merge branch 'dev'
| 
* 2013-11-03: Merge branch 'dev13' into dev
| 
* 2013-11-03: Add Biome Tag. Format is similar to liquid.
| :Biome,Range,Offset,BiomeMapping
| :Biome,Range,BiomeMapping (Offset is assumed 0)
| :Biome,BiomeMapping (Range & Offset are assumed 0)
| Range can be singular value for isometric range, can specify x/y/z. Y is optional. Values cannot be negative.
| Offset can be specified by x/y/z. Y is optional. Values can be negative.
| 
* 2013-11-03: Version++
| 
* 2013-11-03: Add 'postspawn' parent tag. Called after entity intialization during spawning. Identical to 'spawn' parent tag in terms of valid child tags.
| Can be attached to LivingHandler or SpawnListEntry
| As it occurs after the entity has spawned, 'restricting' or not has no effect on the entity. Pretty much only useful for NBT writing.
| Closes #69
| 
* 2013-11-03: Expose the default/global instant despawn distance via configuration.
| Closes #68
| 
* 2013-11-03: Add JAS command CanDespawnHere. Format identical to CanSpawnHere.
| Closes #65
| 
* 2013-11-03: Increase Clod size to 2. Include proper calculations for edges.
| Closes #62
| 
* 2013-11-02: Tweak ChunkStats to count entities per creatureType.
| Chunk Entity totals are current chunk + all neighbouring cells totalling a 3*3 chunk localized area.
| 
* 2013-11-02: Rework BiomeCaps to be per CreatureType.
| 
* 2013-10-31: Biome Chunk Caps. See BiomeCaps.cfg. Enabled/Disabled via config toggle.
  Default cap is 20 entities per chunk. If chunk containing multiple biomes they are averaged.
  
##########################
Changelog version 0.12.9
##########################
* 2013-11-02: Merge branch 'dev'
| 
* 2013-11-02: Fix spawnlistentries not saving optional parameters.
  
##########################
Changelog version 0.12.8
##########################
* 2013-10-31: Merge branch 'dev'
| 
* 2013-10-31: Fixup Package Name lookup to cache by BiomeID. Should incompatability issue with WrapperBiomes in Mystcraft et al.
| 
* 2013-10-20: Fix KillAll command filter not filtering.
| 
* 2013-10-18: Add Chunk Spawn Chance variable to each creature type. Controls how oftren this entity will chunks spawn, if at all. 0 == never, 1.0 == always.
| 
* 2013-10-17: Expose Entity chunk spawn distance in GlobalProperties. Must be >= 1.
| Create Entity chunk count distance parameter which limits the number of chunks away from a player entities must be within to be counted. Setting to <=0 will impose no limit and use all currently loaded chunks.
| Exposed via GlobalProperties. Default is 8 chunks.
| Commands Composition, Locate and CountCap are all determined within the bound of EntityChunkCountDistance.
| 
* 2013-10-16: Fix bug in despawning where non-despawning entities were still eligable for instant-despawning.
| 
* 2013-10-12: Corrent issue in random selection of entities from groups being off by one
| 
* 2013-10-10: Fix biome groups being composed incorrectly
| 
* 2013-10-10: Fix biome not regenerating when empty.
  Tweak entity to generate groups for new entity mapping identical to biomes.
  
##########################
Changelog version 0.12.7
##########################
* 2013-10-20: Fix KillAll command filter not filtering.
  
##########################
Changelog version 0.12.6
##########################
* 2013-10-18: Add Chunk Spawn Chance variable to each creature type. Controls how oftren this entity will chunks spawn, if at all. 0 == never, 1.0 == always.
| 
* 2013-10-18: Expose Entity chunk spawn distance in GlobalProperties. Must be >= 1.
  Create Entity chunk count distance parameter which limits the number of chunks away from a player entities must be within to be counted. Setting to <=0 will impose no limit and use all currently loaded chunks.
  Exposed via GlobalProperties. Default is 8 chunks.
  Commands Composition, Locate and CountCap are all determined within the bound of EntityChunkCountDistance.
  
##########################
Changelog version 0.12.5
##########################
* 2013-10-17: Expose Entity chunk spawn distance in GlobalProperties. Must be >= 1.
  Create Entity chunk count distance parameter which limits the number of chunks away from a player entities must be within to be counted. Setting to <=0 will impose no limit and use all currently loaded chunks.
  Exposed via GlobalProperties. Default is 8 chunks.
  Commands Composition, Locate and CountCap are all determined within the bound of EntityChunkCountDistance.
  
##########################
Changelog version 0.12.4
##########################
* 2013-10-16: Fix bug in despawning where non-despawning entities were still eligable for instant-despawning.
  
##########################
Changelog version 0.12.3
##########################
* 2013-10-12: Corrent issue in random selection of entities from groups being off by one
  
##########################
Changelog version 0.12.2
##########################
* 2013-10-10: Fix biome groups being composed incorrectly
  
##########################
Changelog version 0.12.1
##########################
* 2013-10-10: Fix biome not regenerating when empty.
  Tweak entity to generate groups for new entity mapping identical to biomes.
  
##########################
Changelog version 0.12.0
##########################
* 2013-10-08: Merge branch 'dev' for 0.12.0
| 
*   2013-10-08: Merge branch 'dev12' into dev
|\  
| | Conflicts:
| | 	src/jas/common/DefaultProps.java
| | 	src/jas/common/command/CommandCanSpawnHere.java
| | 	src/jas/common/spawner/ChunkSpawner.java
| | 
| * 2013-10-08: Version++
| | 
| * 2013-10-08: Fixup some livingroup errors where . period was not \\ escaped
| | 
| * 2013-10-08: Detect when new mappings are added and create a group from them even if groups have already been created.
| | 
| * 2013-10-08: Replace reverse mapping looking with bimap.
| | Process mappings twice, once look loading already saved values. Then values not already created.
| | New mappings are gauranteed to be unique, even if only by prefixing with a number.
| | 
| * 2013-10-07: Clearup some logging.
| | 
| * 2013-10-07: Add set algebra operations to entity groups. Union(+), Complement(-), and Intersection(&).
| | 
| * 2013-10-07: Readd set algebra operations to biome groups. Union(+), Complement(-), and Intersection(&).
| | 
| * 2013-10-07: Convert biomegroup parsing to the dynamic style used by entity groups. Still lacks group arithmatic.
| | 
| * 2013-10-07: Fix composition to count entities with multiple types only once for each type.
| | Fix canSpawnHere to deal with entities that have a random chance to spawn by making multiple attempts.
| | 
| * 2013-09-17: Fixup some runtime errors. Seems to work. Still need to revisit commands.
| | 
| * 2013-09-16: First pass at integrating EntityGroups. Compiles, likely doesn't actually work. Commands need tweaking.
| | 
| * 2013-09-16: Include both AtrributeList and BiomeList for old style group configuration where groupID is derived from Configuration Category name.
| | 
| * 2013-09-16: Segregate the default entity groups by modID.
| | 
| * 2013-09-16: Disallow abstract classes from being mapped entities.
| | 
| * 2013-09-16: Add Attribute support for LivingGroups
| | 
| * 2013-09-14: Include topological sorting for entity groups. Allowing entity groups to contain other entity groups.
| | 
| * 2013-09-13: Initial setup of functional entity group registry
| | 
| * 2013-09-12: Cleanup SaveConfig Prop calls in WorldProperties
| | 
| *   2013-09-12: Merge branch 'refactor/spawnlistregistry' into dev12
| |\  
| | | Conflicts:
| | | 	src/jas/common/WorldProperties.java
| | | 	src/jas/common/spawner/creature/handler/CreatureHandlerRegistry.java
| | | 
| | * 2013-09-07: Rename Biome interpreters, handlers and registry to Structure. For clarity.
| | | Clear up some javadoc.
| | | 
| | * 2013-09-07: Cleanup CreatureHandlerRegistry. Rename LivingHandlerRegistry.
| | | 
| | * 2013-09-06: Create and refactor in biome SpawnListRegistry.
| | | 
* | | 2013-10-07: Update environment and mappings for recent forge version on 1.6.4
| | | 
* | | 2013-09-27: Add Dim tag. Accepts a single integer value and compares it to current dimension ID. Is invertible and chainable.
| | | 
* | | 2013-09-18: Revision++
| | | 
* | | 2013-09-18: Fix killall command error when specifying TYPE without player.
| | | Change chunk spawner random from world random() to the chunk random() instance.
| | | 
* | | 2013-09-14: Revision++
| | | 
* | | 2013-09-14: Fix location bug conditioning to be validX && validY && validZ.
|/ /  Tweak /canspawnhere color codes for absnet biome tags and absent spawnlist.
| |   Fix sneaky logger lieing about spawning biome.
| |   
* | 2013-09-11: Remove disabled spawn logging spam
| | 
* | 2013-09-11: Revision++
| | 
* | 2013-09-11: Additional Spawn logging options.
| | SPAWNING, as it has before, controls whether a spawn message is logged.
| | SPAWNING_NAME toggles appending the entity name
| | SPAWNING_TYPE toggles appending the creature type
| | SPAWNING_POS toggles appending the entity position
| | SPAWNING_BIOME toggles appending the biome at position
| | 
* | 2013-09-10: Revision++
| | 
* | 2013-09-10: Fix location tag parsing being off by 1.
| | 
* | 2013-09-08: Revision++
| | 
* | 2013-09-08: Fixed crash when saving after changing save configuration
| | SaveConfig sortByBiome correctly inherits from GlobalProperties.
| | Fix bug in maxHeight and minHeight tag where they were evaluated backwards. They are now also invertible.
| | 
* | 2013-09-07: Revision++
| | 
* | 2013-09-07: Fix NPE when creating accessing world settings when creating new worlds.
|/  
|   
* 2013-09-05: Revision++
| 
* 2013-09-05: Fix critical error in determining entity age. 1.6 causes persistenceRequired to set age to 0. Circumvented by using seperate entity age counter.
| 
* 2013-09-05: Revision++
| 
* 2013-09-05: Fix buildscript not including Compatability module.
| Fix ClassNotFoundException when using KillAll and Locate on a dedicated server. Closes #61
| Fix bug with Entities Tag which consulted the localized name. It instead uses the registration name. It is not case sensitive.
| 
* 2013-09-03: Fix inconvertible type error
  
##########################
Changelog version 0.11.9
##########################
* 2013-09-27: Add Dim tag. Accepts a single integer value and compares it to current dimension ID. Is invertible and chainable.
  
##########################
Changelog version 0.11.8
##########################
* 2013-09-18: Revision++
| 
* 2013-09-18: Fix killall command error when specifying TYPE without player.
  Change chunk spawner random from world random() to the chunk random() instance.
  
##########################
Changelog version 0.11.7
##########################
* 2013-09-14: Revision++
| 
* 2013-09-14: Fix location bug conditioning to be validX && validY && validZ.
| Tweak /canspawnhere color codes for absnet biome tags and absent spawnlist.
| Fix sneaky logger lieing about spawning biome.
| 
* 2013-09-11: Remove disabled spawn logging spam
  
##########################
Changelog version 0.11.6
##########################
* 2013-09-11: Revision++
| 
* 2013-09-11: Additional Spawn logging options.
  SPAWNING, as it has before, controls whether a spawn message is logged.
  SPAWNING_NAME toggles appending the entity name
  SPAWNING_TYPE toggles appending the creature type
  SPAWNING_POS toggles appending the entity position
  SPAWNING_BIOME toggles appending the biome at position
  
##########################
Changelog version 0.11.5
##########################
* 2013-09-10: Revision++
| 
* 2013-09-10: Fix location tag parsing being off by 1.
  
##########################
Changelog version 0.11.4
##########################
* 2013-09-08: Revision++
| 
* 2013-09-08: Fixed crash when saving after changing save configuration
  SaveConfig sortByBiome correctly inherits from GlobalProperties.
  Fix bug in maxHeight and minHeight tag where they were evaluated backwards. They are now also invertible.
  
##########################
Changelog version 0.11.3
##########################
* 2013-09-07: Revision++
| 
* 2013-09-07: Fix NPE when creating accessing world settings when creating new worlds.
  
##########################
Changelog version 0.11.2
##########################
* 2013-09-05: Revision++
| 
* 2013-09-05: Fix critical error in determining entity age. 1.6 causes persistenceRequired to set age to 0. Circumvented by using seperate entity age counter.
  
##########################
Changelog version 0.11.1
##########################
* 2013-09-05: Revision++
| 
* 2013-09-05: Fix buildscript not including Compatability module.
  Fix ClassNotFoundException when using KillAll and Locate on a dedicated server. Closes #61
  Fix bug with Entities Tag which consulted the localized name. It instead uses the registration name. It is not case sensitive.
  
##########################
Changelog version 0.11.0
##########################
* 2013-09-03: Fix inconvertible type error
| 
*   2013-09-03: Merge branch 'dev'
|\  
| | 
| * 2013-09-03: Version++
| | 
| * 2013-09-03: Add Location tag. Evaluates if current location is within a target cube specified by midPopint (X,Y,Z) and a variance in each direction.
| | Format :location,targetX,targetY,targetZ,varX,varY,varZ.
| | Note that the range in along a coordinate specifiecd by a target and variance is from (targetX - varX -> targetX + varX)
| | 
| *   2013-09-03: Merge branch 'primaryRefactor' into dev
| |\  
| | | 
| | * 2013-09-03: Remove depreciated annotations
| | | 
| | * 2013-09-03: Properties renamed appropriately to GlobalSettings to better contrast with WorldSettings
| | | 
| | * 2013-09-02: Enabled WorldProperties to save to config after loading.
| | | Fix structure config saving.
| | | Command save config works.
| | | 
| | * 2013-09-02: Initial refactor. Registry enums reduced to classes and contained in static WorldSettings.
| |/  Reading from configuration files works.
| |   LoadConfig command works.
| |   
| * 2013-09-01: Refactor KeyParserGround and KeyParserSky to extend KeyParserBoolean. Should be easier to maintain.
| | 
| * 2013-09-01: Add IsTamed and IsTameable tags. Chainable and invertible.
| | All entities that extend EntityTameable are compatible.
| | Entities with non-standard hierarchy may have there entity implement the jas.api.ITameable interface.
| | 
| * 2013-09-01: Fixup critical error in /jas canspawnhere
| | 
| * 2013-09-01: Cleanup CommandJasBase.
| | 
| * 2013-09-01: Condense various /jascommands into a single /jas commandname
| | 
| * 2013-09-01: JAS CommandCanSpawnHere is Structure aware. Supports diaplying multiple spawnlist entries.
| | 
| * 2013-08-31: Improve jaslistspawns.
| | Player will target structure instead of biome if present.
| | Biome package name or structure name can be supplied instead of player.
| | When player or target is not supplied command sender player is used.
| | If entity type is not supplied wildcard '*' is used.
| | 
| * 2013-08-30: Fix inconvertible types error
| | 
| * 2013-08-30: Add error handling to compatability module loader
| | 
| *   2013-08-29: Merge branch 'feature/CapCommand' into dev
| |\  
| | | 
| | * 2013-08-29: Locate Command should not accept 3 arguments.
| | | 
| | * 2013-08-29: Cleanup JasCanSpawnHere, If <targetPlayer> is ommitted. Command Sender is assumed target player.
| | | 
| | * 2013-08-29: Add JasListSpawns 0 argument parsing, sending player, * entity
| | | 
| | * 2013-08-29: Cleanup JasCountCap. With no args, target player is sender and wildcard '*' is assumed for entity target.
| | | 
| | * 2013-08-29: Add third parameter to KillAll for filtering entity name. Performs contains check with entity name using provided string.
| | | 
| | * 2013-08-23: Fix command compatability with entries with spaces. Entries with spaces must be surrounded by quotations.
| | | 
| | * 2013-08-21: Add JAS command /jasentitypackage. Sends message to player stating the package name of the class registered to the provided entity name.
| | | Format "/jasentitypackage <EntityName>". Target entity to get package name of.
| | | 
| | * 2013-08-21: Add JAS command /jaslocate. Sends message to player stating location of entities with the provided name or in the provided group.
| | | Displayed name is green if it can despawn, red if it cannot in its current state / location.
| | | Format "/jaslocate <targetPlayer> <EntityTarget>". Target Player is used for dimension to scan. EntityTarget can be creature type or entity name. '*' is used for all.
| | | Format "/jaslocate <EntityCategory>". Uses calling player as target player. EntityTarget can be creature type or entity name. '*' is used for all.
| | | Format "/jaslocate ". Uses calling player as target player. Assumes wildcard '*' for entity type.
| | | Note that due to the possibly large chat messages, an enhanced chat client (primarily one with a scrollbar) is recommended to be able to see them locations.
| | | 
| | * 2013-08-21: Add JAS command /jaskillall. Kills all entities of the target type in the dimension of the player.
| | | Also number of despawnable entities of each type and specific entity.
| | | Format "/jaskillall <targetPlayer> <EntityCategory>". Target Player is used for dimension to scan. EntityCategory is type to kill. '*' is used for all.
| | | Format "/jaskillall <EntityCategory>". Uses calling player as target player. EntityCategory is type to kill. '*' is used for all.
| | | Format "/jaskillall ". Uses calling player as target player. Assumes wildcard '*' for entity type.
| | | Note when using "*" entities of type NONE will be killed, bu only those that extend EntityLiving.
| | | 
| | * 2013-08-21: Add JAS command /jascomposition. Sends chat messege to player number of loaded entities of specified type.
| | | Also number of despawnable entities of each type and specific entity.
| | | Format "/jascomposition <targetPlayer> <EntityCategory>". Target Player is used for dimension to scan. EntityCategory is type to tally. '*' is used for all.
| | | Format "/jascomposition <EntityCategory>". Uses calling player as target player. EntityCategory is type to tally. '*' is used for all.
| | | Format "/jascomposition ". Uses calling player as target player. Assumes wildcard '*' for entity type.
| | | 
| | * 2013-08-19: Fix errors in CountCap when providing player
| | | 
| | * 2013-08-18: Fix compile error Section character must be expressed at utf \ u00A76
| | | 
| | * 2013-08-17: Add JAS command /jascanspawnhere. Sends chat messege to player with whether chosen entity could spawn at players location (neglecting players collision box).
| | | Format "/jascanspawnhere. <targetPlayer> <EntityName>".
| | | 
| | * 2013-08-17: Add JAS command /jaslistspawns. Sends chat messege to player with valid spawn list entries contained in the biome the target player is in of the specified type
| | | Format "/jascommandcap <targetPlayer> <EntityCategory>". Entity Category is not case sensitive and * will do all.
| | | 
| | * 2013-08-17: Add JAS command /jascountcap. Sends chat messege to player comparing current entity category numbers compared against their respective cap.
| |   Format "/jascommandcap <target Dim> <EntityCategory>". targetDim can be int or player. Entity Category is not case sensitive and * will do all.
| |   
| * 2013-08-29: Merge branch 'compatability/tfsupport' into dev
| | 
| * 2013-08-29: Build script to create a standalone compatability module.
| | 
| * 2013-08-29: Multiple Eclipse environments. One for developing the compatibility module and another to use the compiled compat module loaded via the mods folder.
| | 
| * 2013-08-29: Seperate Compatability code into its own mod. Create CompatabilityRegistrationEvent for registering objects outside JAS.
|   Create logicless classes representing TF forest for compiling. Proper JAS development should be done with the obfuscated compatability module alongside obfiscated TF (and etc.).
|   
* 2013-06-27: Merge branch 'dev'
| 
* 2013-06-27: Gamerule doCustomMobSpawning is added to all worlds on WorldLoad for MCPC compatability.
| Should Close #57
| 
* 2013-06-21: Merge branch 'dev'
| 
* 2013-06-16: Merge branch 'dev'
| 
* 2013-06-14: Merge branch 'dev'
| 
* 2013-06-13: Merge branch 'dev'
| 
* 2013-06-10: Merge branch 'dev'
| 
* 2013-06-09: Revision++
| 
* 2013-06-09: Merge branch 'dev'
| 
* 2013-06-07: RevisionNumber++
| 
* 2013-06-07: Merge branch 'dev'
| 
* 2013-06-07: Merge branch 'dev'
| 
* 2013-06-04: Merge branch 'dev' for 0.8.0
| 
* 2013-05-27: Minor Version++
| 
* 2013-05-27: Merge branch 'dev'
| 
* 2013-05-22: Merge branch 'dev'
| 
* 2013-05-20: Merge branch 'dev'
| 
* 2013-05-09: Merge branch 'dev'
| 
* 2013-05-04: Merge branch 'dev'
| 
* 2013-04-25: Merge branch 'dev'
| 
* 2013-04-24: Merge branch 'dev' for 0.5.1
| 
*   2013-04-17: Merge branch 'dev'
|\  
| | 
| * 2013-04-17: MajorVersion++
|   
* 2013-04-17: Merge branch 'dev'
| 
* 2013-04-14: Merge branch 'dev'
| 
* 2013-04-13: Merge branch 'dev'
| 
* 2013-04-13: Merge branch 'dev'
| 
* 2013-04-13: Merge branch 'dev'
| 
* 2013-04-11: Merge branch 'dev'
| 
* 2013-04-06: Merge branch 'dev' for version 0.2.0: BiomeHandlers
| 
* 2013-03-31: Version++
  
##########################
Changelog version 0.10.0
##########################
##########################
Changelog version 0.9.7
##########################
* 2013-08-06: Revision++
| 
* 2013-07-26: Add Biome blacklist to GlobalProperties.cfg. Setting any biome to true will disable JAS's ability to spawn entities in those biomes.
| Any Biome in the blacklist will not be cleared by the "Empty Vanilla SpawnLists on Start" setting.
| 
* 2013-08-06: Update Eclipse Classpaths
| 
* 2013-07-18: Revision++
| 
* 2013-07-18: Fix issue with tempSaveSettings not saving actual setup.
| 
* 2013-07-17: Update eclipse for 1.6.2
| 
* 2013-07-17: Fix issue in structure spawn list logic when accessing reflected fields from child.
| 
* 2013-07-03: Initial port to 1.6. Everything should work. Entities extended EntityLivingBase instead of EntityLiving will not have support yet.
| 
* 2013-07-03: Update Eclipse for 1.6 Workspace. Server still not working, but is broken in Forge eclipse as well.
  
##########################
Changelog version 0.9.4
##########################
*   2013-06-27: Merge branch 'dev'
|\  
| | 
| * 2013-06-27: Revision++
| | 
| * 2013-06-27: Gamerule doCustomMobSpawning is added to all worlds on WorldLoad for MCPC compatability.
|   Should Close #57
|   
* 2013-06-27: Gamerule doCustomMobSpawning is added to all worlds on WorldLoad for MCPC compatability.
  Should Close #57
  
##########################
Changelog version 0.9.3
##########################
* 2013-06-21: Merge branch 'dev'
| 
* 2013-06-21: Remove log spam caused by replaced Nether Biome
  
##########################
Changelog version 0.9.2
##########################
* 2013-06-16: Merge branch 'dev'
| 
* 2013-06-16: Fix bug in import caused premature file-creation
  
##########################
Changelog version 0.9.1
##########################
* 2013-06-14: Merge branch 'dev'
| 
* 2013-06-14: Fix magic NPE bug when group contains invalid biome. Prints Warning Message.
  Revision++
  
##########################
Changelog version 0.9.0
##########################
* 2013-06-13: Merge branch 'dev'
| 
* 2013-06-13: MinorVersion++
| 
* 2013-06-13: Merge branch 'dev0.9' into dev
| 
*   2013-06-13: Merge branch 'feature/writeNBTtag' into dev0.9
|\  Closes #48
| | 
| * 2013-06-13: Add writeNBT tag. Valid for SpawnList and LivingHandler {spawn} tags.
| | 
| * 2013-06-13: Create class to wright nbt data to NBTTagCompound from a string format.
|/  Format essentially functions as "tagetTag,TargetTagID,value". Container tags do not, obviously, have a value.
|   Add some parsing options to ParsingHelper for additional data types.
|   
* 2013-06-13: Fix spawning bug when spawnlistentry spawn is not enabled.
| 
* 2013-06-12: Add Random Tag. Evaluates to the format of randomIntBetween(0->RandomRange) + RandomOffset <= maximum.
| Format `:random,RandomRange,RandomOffset,maximum`
| 
* 2013-06-12: Add Entities tag. Search for entity by name within range. Identical to player tag, with an added name parameter.
| Format :entities,searchName,minSearch,maxSearch,min#,max#
| Closes #49
| 
* 2013-06-12: Fix allbiomes null biomes bug
| 
*   2013-06-12: Merge branch 'feature/biomeAttribute' into dev0.9
|\  Closes #51
| | 
| * 2013-06-12: Remove old unused method to clear vanilla spawnlist
| | 
| * 2013-06-12: Call BiomeDictionary registerall() to ensure all biomes are registered in post-init.
| | 
| * 2013-06-12: Add 'allbiomes' attribute.
| | 
| * 2013-06-12: Attributes and Mappings can be added or subtracted when resolving biomegroups by adding a '+' or '-' in front of their names.
| | '+' is the default operator.
| | 
| * 2013-06-12: BiomeGroups should store their content strings used to determine applicable biomes and attributes
| | 
| * 2013-06-12: Attributes can be added to BiomeGroups by adding their name prefixed with 'A|'
| | 
| * 2013-06-11: Each BiomeDictionary Type is represented by an attribute. Custom attributes can be added similarly to custom biome groups.
|/  Neither Attribute IDs, BiomeGroups, or BiomeMappings are not allowed to be the same. BiomeMappings overwrite Attribute IDs overwrite BiomeGroups.
|   
* 2013-06-11: Fix issue with alternating shared save configurations from different worlds
| 
*   2013-06-11: Merge branch 'feature/useability' into dev0.9
|\  Closes #52
| | 
| * 2013-06-11: All Entities shouldSpawn properties default to true.
| | Spawning still does not occur if the entity type is NONE or wieght <= 0.
| | 
| * 2013-06-11: Clear vanilla spawnlists is enabled by default, still toggleable by configuration.
| | 
| * 2013-06-11: When EmptyVanillaSpawnlist is enabled, vanilla spawn list entries are still imported.
|/  JAS now searches all vanilla entry types irrelevent to the type of Entity JAS detects.
|   
* 2013-06-11: Cleanup some commented out crap
| 
* 2013-06-11: Fix bug when switching between Universal and modConfig directory styles where all entities would be printed into all mod configs.
| 
*   2013-06-11: Merge branch 'feature/spawnListOptionals' into dev0.9 Closes #30
|\  
| | 
| * 2013-06-11: Tweak parsing property tag failure message to better indicate which parent tag is failing
| | 
| * 2013-06-11: Setup SpawnList optional with valid property keys
| | 
| * 2013-06-11: LivingHandler and SpawnList optional can be chained together by prefixing either or both with the AND '&' symbol.
| | Spawn parent tag now considers the operands '&' or '|' as valid prefixes.
| | 
| * 2013-06-11: SpawnListEntry Configured to read and save optional parameters
|/  
|   
* 2013-06-11: Merge branch 'feature/parserUpgrade' into dev0.9
| 
* 2013-06-11: Add Toggle for Universal Entity CFGs instead of modSpecific.
| Improve toggling to remeber previous saved sorting. Applies to sortByBiome as well.
| Closes #47
| 
* 2013-06-10: Add SaveCurrent loaded to configuration for StructureHandler
| 
* 2013-06-10: Add SaveCurrent loaded to configuration for LivingHandler and SpawnListEntries
| 
* 2013-06-10: Add SaveCurrent loaded to configuration for Entity Categories
| 
* 2013-06-10: Refactor configuration proerty getters into cutom Configuration class
| 
* 2013-06-10: Add SaveCurrent loaded to configuration for BiomeGroups
  
##########################
Changelog version 0.8.4
##########################
*   2013-06-10: Merge branch 'dev'
|\  
| | 
| * 2013-06-10: Fully fix the NPE when accessing entity name for logging after spawning.
|   
* 2013-06-09: Revision++
  
##########################
Changelog version 0.8.3
##########################
*   2013-06-09: Merge branch 'dev'
|\  
| | 
| * 2013-06-09: Adds ability to set default save_name Closes #50
|   
* 2013-06-07: RevisionNumber++
  
##########################
Changelog version 0.8.2
##########################
* 2013-06-07: Merge branch 'dev'
| 
* 2013-06-07: Should fix issue reading an entities name before its initialized
  
##########################
Changelog version 0.8.1
##########################
* 2013-06-07: Merge branch 'dev'
| 
* 2013-06-05: Fix infinite folder issue.
  
##########################
Changelog version 0.8.0
##########################
*   2013-06-04: Merge branch 'dev' for 0.8.0
|\  
| | 
| * 2013-06-04: MinorVersion++
| | 
| * 2013-06-03: Add nearby player tag. Format :player,minSearch,maxSearch,min#,max#. Chainable, invertible. Closes #34
| | Fix KeyParserRange error: bounds should be inclusive.
| | 
| * 2013-06-03: Fixed issue in range Calculation for cases where min>max.
| | When max>min, range is min->max
| | When min>max, range is max->+INF & -INF->min
| | 
| * 2013-06-03: Light and Torchlight tags are now invertable.
| | 
| * 2013-06-03: Add Origin Range Tag. Invertable and chainable. Checks if distance to spawn is within range. Format identical to light or torchlight. Limited to integers.
| | Valid for category and livinghandler and for spawn and despawn. Closes #42.
| | 
| * 2013-06-02: Fix issue where blockRange was not considered valid tag for spawning. Closes #45.
| | 
| * 2013-06-02: Add ModSpawn Tag; calls default getCanSpawnHere. Invertable and Chainable. Closes #39
| | 
| * 2013-06-02: Refactor isValidLocation KeyParser evaluate to accept Entity if applicable
| | 
| * 2013-06-02: Set JAS to load after everything. Closes #44
| | 
| * 2013-06-01: Clarifying Config Comments about OS case-sensitivity / invalid characters.
| | 
| *   2013-06-01: Merge branch 'refactor/worldselect' into dev
| |\  
| | | 
| | * 2013-06-01: Configuration importing on world creation can be setup via SaveConfig.cfg
| | | 
| | * 2013-06-01: SaveName, while defaulting to worldname, can now be configured via SaveConfig.cfg
| |/  Closes #32
| |   
| * 2013-06-01: Merge branch 'refactor/biomegroup' into dev
| | 
| * 2013-05-31: BiomeGroups with 0 entries should be declared.
| | 
| * 2013-05-31: Default BiomeGroups Immutable.
| | Use/allow custom mappings for simpler package names.
| | Closes #43
| | 
| * 2013-05-22: Default BiomeGroups Immutable
|   
* 2013-05-27: Minor Version++
  
##########################
Changelog version 0.7.2
##########################
* 2013-05-27: Merge branch 'dev'
| 
* 2013-05-27: Fix bug in handling MaxSpawnRange tag
  
##########################
Changelog version 0.7.1
##########################
* 2013-05-22: Merge branch 'dev'
| 
* 2013-05-22: Remove forced living handler isInLiquid check for all entities using {spawn}
  
##########################
Changelog version 0.7.0
##########################
* 2013-05-20: Merge branch 'dev'
| 
* 2013-05-20: Major Version++
| 
* 2013-05-19: Allow toggling Spawn logging independent of debug logging. Debug logging still functions as master switch.
| Closes #41
| 
* 2013-05-19: Custom Entity Categories can be added by entering their names in the extra categories section of CreatureType.cfg
| Closes #40
| 
* 2013-05-18: Tags to check if entity is on the "top block" or "filler block" of the biome it is standing in.
| 
* 2013-05-18: Change Sky tag to strict can see sky check. Introduce ground as sky loose sky check.
| 
*   2013-05-18: Merge branch 'configCategory' into dev
|\  
| | 
| * 2013-05-18: Torch Light Tag
| | 
| * 2013-05-15: Change format of rotation-potion tags. Rotation-Position seperated by commas, internal delimeter / seperating x/y/z
| | Change integer parsing to remove non-numeric characters. Allowing commenting, brackets.
| | 
| * 2013-05-13: Fix isInverted checks to consider that ! may be second character
| | 
| * 2013-05-13: Fix parsing of special operators !|& such that order does not matter
| | 
| * 2013-05-13: Change proprety tag delimter parsing to be done by KeyParser. Tag is still assumed seperated by comma {tag,valueToBeParsed}
| | 
| * 2013-05-13: Add Difficulty Tag
| | 
| * 2013-05-13: Implement tags for each category to mirror default behaviour.
| | Remove unneeded type classes.
| | 
| * 2013-05-12: Category Tag support. "" Will use default pre-programmed logic. Adding {spawn} will function as regular.
|/  
|   
* 2013-05-12: Add additional Tags Liquid, Normal, Opawu, Sky, and SolidSide
| 
* 2013-05-11: Refactor Keys to call KeyParser Class. Delegates parsing through enum. Generalizing all parsing.
  
##########################
Changelog version 0.6.1
##########################
* 2013-05-09: Merge branch 'dev'
| 
* 2013-05-09: Minor Version++
| 
* 2013-05-09: Remove data dependency of static spawner classes. Hypotehtically this reduced any chance of concurrency issues if multiple world update loops are called in different threads. Not convinced this is neccesarily a problem, but was poor practice non the less.
| 
* 2013-05-09: Fix obfuscated name issue. Entityliving age name is incorrect.
| 
* 2013-05-09: Rework ClassPath to UserLibrary. Easy to add extra mods without specific lined dependencies for each.
| 
* 2013-05-09: Update Mappings for 152
  
##########################
Changelog version 0.6.0
##########################
* 2013-05-04: Merge branch 'dev'
| 
* 2013-05-04: Major Version++
| 
* 2013-05-04: Remove deprecianted methods
| 
* 2013-05-04: Change can seeSkyCheck to check if higher than highest non-opaque block
| 
* 2013-05-04: Improve spawn messages to include creature type, register name, and localized name.
| 
* 2013-05-03: Add minSpawnHeight and maxSpawnHeight chainable tags.
| 
* 2013-05-03: Merge branch 'logicalParsing' into dev
| 
* 2013-05-03: Applying improved tag parsing with & and | operators to despawning.
| 
* 2013-05-03: Change Parsing of Spawn tag to include & and | operations.
  
##########################
Changelog version 0.5.2
##########################
* 2013-04-25: Merge branch 'dev'
| 
* 2013-04-25: MinorVersion++
| 
* 2013-04-25: Actually Fixes issue with null spawnlists
  
##########################
Changelog version 0.5.1
##########################
* 2013-04-24: Merge branch 'dev' for 0.5.1
| 
* 2013-04-24: MinorVersion++
| 
* 2013-04-24: Clear spawnlist twice to catch everything. Closes #25
| 
* 2013-04-24: Fix up debug logging messages. Closes #24
| 
* 2013-04-24: Added a null check when emptying spawnlists to catch when other mods null them. Closes #26
| 
* 2013-04-24: Add and Cleanup some log messages.
| 
* 2013-04-17: MajorVersion++
  
##########################
Changelog version 0.5.0
##########################
*   2013-04-17: Merge branch 'dev'
|\  
| | 
| * 2013-04-17: MajorVersion++
| | 
* | 2013-04-17: Merge branch 'dev'
|/  
|   
* 2013-04-16: Add MaxDespawnDist and minDespawnAge as global paramaters with respective tags; maxSpawnRange and despawnAge
| Closes #17
| Closes #21
| 
* 2013-04-16: Tweak extended Entity Coutning to be done at the pack level. Closes #20
| 
* 2013-04-16: Refactor passive Spawning loop to use for loops instead of while loops. MUCH cleaner.
| 
* 2013-04-15: Fix issue with Monster spawnlist triggering during "Peaceful". Closes #19.
| 
* 2013-04-15: Fixup creature cap not counting correctly.
| 
* 2013-04-15: Setup Creature Cap tag "cap" Spawning tag.
| 
* 2013-04-15: Tweak naming scheme of counter for clarity
| 
* 2013-04-15: Creature Specific Caps. Closes #7
| 
* 2013-04-15: Implement Entity Count Cache. Counts every 60 ticks. Closes #18
| 
* 2013-04-15: Creating counting hashmaps for creature type and quantity.
| 
* 2013-04-15: Enfore 1 CreatureType to 1 in CreatureType
  
##########################
Changelog version 0.4.1
##########################
* 2013-04-14: Merge branch 'dev'
| 
* 2013-04-14: Fix issue with !Despawn and !Spawning tags not being read.
  Minor Version++
  
##########################
Changelog version 0.4.0
##########################
*   2013-04-13: Merge branch 'dev'
|\  
| | 
| * 2013-04-13: Include Fix for null spawnlists
| | 
* |   2013-04-13: Merge branch 'dev'
|\ \  
| |/  
| |   
| * 2013-04-13: Fix issue Master Config not transfering OptionalSettings to World Config
| | 
* | 2013-04-13: Merge branch 'dev'
|/  
|   
* 2013-04-13: Major Version++
| 
* 2013-04-13: OptionalSettings that set behaviour should use isInverted instead of flipping boolean
| 
* 2013-04-13: Add inverted !spawn and !despawn tags. Closes #15
| 
* 2013-04-13: Refaction OptionalSettings to CommonBase
| 
* 2013-04-13: Make Min range for entity despawn a world specific proeprty.
| 
* 2013-04-13: Add Sky and NotSky tags for spawning and despawning. Closes #16
| 
* 2013-04-13: Refactor Optional Parsing into its own helper class to reduce redundency
| 
* 2013-04-13: Add Global DespawnDistance property and spawnRange tag. Closes #12
| 
* 2013-04-12: Check Entitycap after every spawn. Should close #13
| 
* 2013-04-12: Entity despawn at sq. distance greater than 16384. Closes #14
| 
* 2013-04-12: Merge branch 'biomeGroups' into dev
| Closes #5
| 
* 2013-04-12: Add a ReferenceBiome category for easy adding biomes to lists.
| 
* 2013-04-12: Convert entries of biomeName to pckgName and BiomeGroup
| 
* 2013-04-12: Create BiomeGroup Registry. Read - Load from BiomeGroups.cfg.
  Refactor Some packaging to fit biomegroup classes in.
  
##########################
Changelog version 0.3.0
##########################
* 2013-04-11: Merge branch 'dev'
| 
* 2013-04-11: Major Version++
| 
* 2013-04-11: Spawnlist entries generated independently of shouldSpawn toggle. Still won't be added to spawnList if false. Closes #11
| 
* 2013-04-11: Fix default min/max light range for spawning/despawning
| 
* 2013-04-11: Stop error reporting on empty optional parameters
| 
* 2013-04-10: Remove hard dependency on TwilightForest such that the compatability package is only added when TF is present
| 
*   2013-04-10: Merge branch 'dev' of https://github.com/Crudedragos/JustAnotherSpawner into dev
|\  
| | 
| * 2013-04-06: Fix some annoying Obfuscation Check Issues
| | 
| * 2013-04-06: Fixup some build errors. This is a major, not minor version.
|   
* 2013-04-10: Add Config options to disable doMobSpawning gamerule on server start.
| Add Config options to empty vanilla spawnLists on server start.
| 
* 2013-04-10: Fixup refactored Helper class references
| 
*   2013-04-10: Merge branch 'optionalOptions' into dev
|\  
| | 
| * 2013-04-09: Remove unused useModLocationCheck and Forcedespawn variables.
| | 
| * 2013-04-09: Auto-Convert Old-format to new tag format. Change category comment to reflect new format.
| | 
| * 2013-04-09: Give both OptionalSettings a common base. Create Enum for common strings.
| | 
| * 2013-04-09: Add String parsing for despawning properties, replaces forceDespawn.
| | 
| * 2013-04-09: Implement Optional String Parsing for Spawning Restrictions.
|   UseModLocation no longer used internally.
|   
* 2013-04-10: Add Twilight Forest Interpreter
  
##########################
Changelog version 0.2.0
##########################
*   2013-04-06: Merge branch 'dev' for version 0.2.0: BiomeHandlers
|\  
| | 
| * 2013-04-06: Fix some annoying Obfuscation Check Issues
| | 
| * 2013-04-06: Fixup some build errors. This is a major, not minor version.
| | 
| * 2013-04-06: Version++
| | 
| * 2013-04-06: Cleanup some Code to reduce Log Spawm
| | 
| *   2013-04-06: Merge branch 'biomeHandler' into dev
| |\  
| | | 
| | * 2013-04-06: Add StructureSpawners to Mineshaft and Stronghold.
| | | Fix bug, custom getCanSpawnHere was never being called
| | | 
| | * 2013-04-06: Add Call to BiomeHandler from Creature getSpawnListEntry.
| | | Will only spawn the structure Spawn entity if it is the same creature type that is being processed.
| | | If an empty structure spawn list if returned, spawning continues as normal from biome spawn lists.
| | | Finished Swamp BiomeInterpretors. Created Nether interpretor for Nether Fortresses.
| | | Strucure spawns occur for both passive and chunk spawning.
| | | 
| | * 2013-04-06: BiomeInterpreter Interface to handle each specicif biome requried. Gets structures and spawnlists.
| |/  Generic BiomeHandler to read the different interpreters and read/write them to Coniguration.
| |   
| *   2013-04-05: Merge branch 'gui' into dev with GUI with GUI disabled to get refactored of base code requried
| |\  Other features should be able to be developed with those changes
| | | 
| | * 2013-04-05: Fix bug in creatureType where spawn rate is not used in constructInstance
| | | 
| | * 2013-04-05: Tweak LivingHandler immutable methods to be single paramter and call local instanceConstructor
| | | 
| | * 2013-04-05: Tweak CreatureType immutable methods to be single paramter and call local instanceConstructor
| | | 
| | * 2013-04-05: Servers do not have keyboards.
| | | 
| | * 2013-04-05: Create packets to sync server state to client on gui open.
| | | SpawnListEntry implements equals && hashcode; defined by biome and entityclass.
| | | 
| | * 2013-04-04: Refactor CreatureHandlerREgistry methods such that the functionality needed can be Called Client Side.
| | | It should also be more maintanable.
| | | 
| | * 2013-04-03: Create Spawner Main Menu.
| | | 
| | * 2013-04-03: Gui initialised with background textures stolen from Project Zulu Limited Spawner
| | | 
| | * 2013-04-03: Create OpenGUI Keybinding
| | | 
| | * 2013-04-03: Basic Gui infastructure; GuiHandler, GuiID
| | | 
| | * 2013-04-03: Basic Network infastructure. PacketHandler, PacketManger, PacketID.
| |/  
| |   
| * 2013-04-03: Refactored LivingHandler and SpawnListEntry configuration out of HandlerRegistry
| | 
| * 2013-04-03: Move Creature Type Config generation into CreatureType Class from CreatureRegistry
| | 
* | 2013-03-31: Version++
|/  
|   
* 2013-03-31: JAS should not need client to run
  
##########################
Changelog version 0.1.1
##########################
* 2013-03-30: Version++
| 
* 2013-03-30: Fix for Server Crash by Calling incorrect getWorldName()
  
```
